1

我正在将一组 RhinoScript (Python) 函数移植到 C#,以便开发一组自定义 Grasshopper 组件。

我的问题是我无法访问某些 RhinoScript 方法,例如VectorUnitize(), VectorScale()PointAdd().

我似乎在 C# 中找不到任何包含这些的引用。有没有人对这种事情有任何经验可以为我指明正确的方向?

我正在使用的 RhinoScript:

# FIND THE ALIGNMENT VECTOR
aVec = self.AlignmentVector(neighborAgents, neighborAgentsDistances)
if rs.VectorLength(aVec) > 0:
    aVec = rs.VectorUnitize(aVec)
aVec = rs.VectorScale(aVec, self.alignment)

# FIND THE SEPARATION VECTOR
sVec = self.SeparationVector(neighborAgents, neighborAgentsDistances)
if rs.VectorLength(sVec) > 0:
    sVec = rs.VectorUnitize(sVec)
sVec = rs.VectorScale(sVec, self.separation)

# FIND THE COHESION VECTOR
cVec = self.CohesionVector(neighborAgents)
if rs.VectorLength(cVec) > 0:
    cVec = rs.VectorUnitize(cVec)
cVec = rs.VectorScale(cVec, self.cohesion)

# ADD ALL OF THE VECTOR TOGETHER to find the new position of the agent
acc = [0, 0, 0]
acc = rs.PointAdd(acc, aVec)
acc = rs.PointAdd(acc, sVec)
acc = rs.PointAdd(acc, cVec)

# update the self vector
self.vec = rs.PointAdd(self.vec, acc)
self.vec = rs.VectorUnitize(self.vec)

到目前为止我所拥有的(不多:/):

// Find the alignment Vector
Vector3d aVec = AlignmentVector(neighborAgents, neighborAgentsDistances);
if (aVec.Length > 0)
{
    aVec.Unitize();
}
aVec = ????
4

2 回答 2

2

在这里你可以看到所有的 rhino 脚本功能是如何使用 Rhino Common 实现的: https ://github.com/mcneel/rhinoscriptsyntax/tree/rhino-6.x/Scripts/rhinoscript

于 2018-11-06T07:02:21.510 回答
2

根据Add 函数的 Vector3d 文档,您还可以使用 Vector3d 的重载 + 运算符。对于这些几何类型中的大多数,RhinoCommon 提供了预期的重载。

因此,要缩放一个向量,您可以将它与一个标量相乘,在您的情况下为alignment,separationcohesion

Vector3d vec1 = getyourvector();
vec1.Unitize();
vec1 *= alignment;

Vector3d vec2 = getyourvector();
vec2.Unitize();
vec2 *= cohesion;

Vector3d vec3 = getyourvector();
vec3.Unitize();
vec3 *= separation;

Vector3d acc;
acc += vec1;
acc += vec2;
acc += vec3;
于 2018-10-31T21:20:17.037 回答